# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTIBILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
# ======================================================================

__version__= '2.4'

from Globals import HTML, HTMLFile, DTMLFile, MessageDialog, Persistent
#from webdav.common import rfc1123_date
#from DateTime import DateTime
import OFS,Acquisition, AccessControl.Role
from OFS.DTMLMethod import decapitate
import Globals, sys, traceback
from OFS.DTMLDocument import DTMLDocument
from AccessControl import getSecurityManager


import os,time,string



manage_addPHPForm = HTMLFile('PHPAddForm', globals())

def manage_addPHP(self, id, title='PHP object', REQUEST=None, submit=None):
    """Add a PHP Object """
    ob=PHPDocument(id, title)
    ob.title=title
    id=self._setObject(id, ob)
    if REQUEST is not None:
        try: u=self.DestinationURL()
        except: u=REQUEST['URL1']
        if submit==" Add and Edit ": u="%s/%s" % (u,quote(id))
        REQUEST.RESPONSE.redirect(u+'/manage_main')
    return ''









class PHPDocument(OFS.SimpleItem.Item,DTMLDocument):
    """PHP object."""    
       
    meta_type = 'PHP Document'
    icon = 'php.gif'

 
    manage_about = HTMLFile('README', globals())
    manage_help = HTMLFile('help', globals())
    manage_options=({'label':'Edit', 'action':'manage_main'},
                    {'label':'Properties', 'action':'manage_propertiesForm'},
                    {'label':'View', 'action':''},
                    {'label':'Proxy', 'action':'manage_proxyForm'},
                    {'label':'Security', 'action':'manage_access'},
                    {'label':'Help', 'action':'manage_help'},
                   )
   
#    __ac_permissions__=( 
#        ('Change PHP Document',   ('manage_edit', 'manage_upload', 'PUT')),
#        ('Manage PHP Document', ('manage_tabs', 'manage_main','manage_about','manage_elementHelp')),
#        )




    def __init__(self, id, title):
        """ init method """
        self.id=id
        self.title=title
        self.globals=''
        self._vars=''
        self.raw="""
<dtml-var standard_html_header>

<h2>PHP Document: <dtml-var title_or_id></h2>

<form method="post">
<input type="text" name="u_name" value="<dtml-if u_name>&dtml-u_name;<dtml-else>Your name</dtml-if>">
<input type="submit" value="Hello">
</form>

<?
   $name=$HTTP_GET_VARS["u_name"];
   echo "Hello World!<br>Today <b>ZopeTime</b> is <u><dtml-var ZopeTime></u><br>";
   if(isset($name))echo "Hello <b>$name</b>!<br>";
?>

<dtml-var standard_html_footer>
"""






    def __call__(self, client=None, REQUEST={}, RESPONSE=None, **kw):
        """Render the document given a client object, REQUEST mapping,
        Response, and key word arguments."""

        if hasattr(self, 'aq_explicit'):
            bself=self.aq_explicit
        else:
            bself=self

        security=getSecurityManager()
        security.addContext(self)
        try:
            if client is None:
                #you called this document like <dtml-var your_php_document>
                #from another DTML method or DTML document or PHP document ...
                r=apply(HTML.__call__, (self, bself, REQUEST), kw)
                if not self._cache_namespace_keys:
                    self.ZCacheable_set(r)
            else:
                #called by web (by URL)
                r=apply(HTML.__call__, (self, (client, bself), REQUEST), kw)
                
            if type(r) is not type('') or RESPONSE is None:
                if not self._cache_namespace_keys:
                    self.ZCacheable_set(r)
        finally:
              security.removeContext(self)
        #r=self.raw
        tmp=string.replace(str(time.time()),".","_")
        file1=tmp+".txt"
        file2=tmp+".out"
        #is Windows ??????
        _iswin32 = (sys.platform == 'win32')
        #on non Windows (Unix ?) use /tmp/ folder
        if not _iswin32:
           file1='/tmp/'+file1
           file2='/tmp/'+file2
        f=open(file1,"wt")
        f.write(r)
        f.close()
        #env_sav=os.environ
        QUERY_STRING=""
        if client is not None:
            try:
                for i in REQUEST.form.items():
                    QUERY_STRING=QUERY_STRING+"%s=%s&" % (i[0],i[1])
                try:    os.putenv("QUERY_STRING",QUERY_STRING)
                except:
                   #can't SET QUERY_STRING
                   pass
            except:
                #can't access REQUEST.form
                pass

        x=os.system("php "+file1+" > "+file2)
        if x==0:
          f=open(file2,"rt")
          lines=f.readlines()
          f.close();
          rez=string.join(lines,'')
        else:
          rez="Error! Can't find PHP. Put php somewhere in search path!"

        try:    os.putenv("QUERY_STRING","")
        except:
          #can't SET QUERY_STRING
          pass

        try:
          os.unlink(file2)
          os.unlink(file1)
        except: pass
        #os.environ=env_sav
        if RESPONSE is not None:
            rez = decapitate(rez, RESPONSE)

        return rez






Globals.default__class_init__(PHPDocument)

manage_editForm=HTMLFile('PHPEdit', globals())
manage=manage_main=manage_editDocument=manage_editForm

